﻿using System.Collections.Generic;

namespace Eingabeverwaltung.Metamodell
{
	public class ADT
	{
		public readonly List<Sort>      sorts;
		public readonly List<Operation> operations;
		public readonly List<Axiom>     axioms;

		public ADT(List<Sort> sorts, List<Operation> operations, List<Axiom> axioms)
		{
			this.sorts      = sorts;
			this.operations = operations;
			this.axioms     = axioms;
		}

		public string ToString(bool showMetadata)
        {
            string res = "ADT:\r\n";
            res += "Sorten: ";
            foreach (Sort sort in sorts)
                res += sort.name + ", ";
            res = res.Remove(res.Length - 2);
            res += "\n";
            res += "Operationen:\n";
            foreach (Operation op in operations) res += op.ToString(showMetadata);
            if (axioms.Count != 0)
            {
                res += "Variablen: ";
                foreach (Variable v in axioms[0].eq.variables)
                    res += v.ToString();
                res += "\n";
                res += "Axioms:\n";
                foreach (Axiom ax in axioms)
                    res += "   " + ax.name + " : " + ax.eq.leftTree.ToString() + " = " + ax.eq.rightTree.ToString() + "\n";
            }
            return res;
        }
	}
}
