﻿using Eingabeverwaltung.Metamodell;
using System;

namespace Ueberpruefung.CheckInduction
{
    /// <summary>
    /// checks error 36 
    /// @pre: constructors of cases must be set
    /// </summary>
    public class CheckIndHypNotUsedInIA : ElementChecker
    {
        /// <summary>
        /// checks error 36 
        /// @pre: constructors of cases must be set
        /// </summary>
        public CheckIndHypNotUsedInIA() : base() { }
        public override bool check(Element e)
        {
            if (e is InductionCase indC)
            {
                if (indC.Constructor != null && indC.Constructor is BasicConstructor)
                {
                    bool result = true;
                    foreach (TransformationStep ts in indC.proof.transformationSteps)
                        if (ts.rule is InductionHypothesis)
                        {
                            result = false;
                            ts.errors.Add(new Error(36));
                        }
                    return result;
                }
                else return true;
            }
            else throw new InvalidOperationException();
        }
    }
}
